To submit pull requests to the Graal compiler, you need to sign the [Oracle
Contributor Agreement][1].

All pull requests should be given an [Assignee][2]. The assignee is responsible
for adding the `accept` label to the pull request once they have completed a
review and are satisfied that all review comments have been addressed. After the
`accept` label has been applied, the pull request author can merge the pull
request if they have write permission. Otherwise someone with the necessary
permissions (preferably the assignee) will do the merge. The pull request author
must remove the `accept` label if they make further semantic changes (i.e.,
changes other than rebasing or squashing commits) to the pull request after the
`accept` label was applied. If you don't have write permission, the reviewer(s)
will work with you to ensure the pull request is in a ready-to-merge state
before applying the `accept` label.

If you don't know who to designate as the Assignee or don't have permission
to set the Assignee, leave it blank and one of the project owners will do it.

[1]: http://www.oracle.com/technetwork/community/oca-486395.html
[2]: https://help.github.com/articles/assigning-issues-and-pull-requests-to-other-github-users/
